global fr_i q;			 #### new ###
global kd l c x0 omega;

#kd=100.0; l=0.8; c=2.0; x0=pi/9.0;
kd=1500.0; l=0.8; c=2.0; x0=pi/9.0;
function y = rpm(x)
  y = x/60*2*pi;
endfunction

q=[0,0];
om0 = rpm(10);
om1 = rpm(1000);

function y = f(p)
  global kd l c x0 fr_i q;
  q(fr_i) = p; om=q(1); x=q(2);
  y = kd .* (x .- x0) + om**2 .* sin(x).*(l.*cos(x).-1);
endfunction

function dy = eom(y,t)
  global kd l c x0 omega;
  dy(1) = y(2);
  dy(2) = -c*y(2) - kd*(y(1) - x0) - (omega**2)*sin(y(1))*(l*cos(y(1))-1);
endfunction

function mat = jac(y)
  global kd l c x0 omega;
  mat=[0, 1; -kd-(omega**2)*(l*cos(2*y(1))-cos(y(1))), -c];
endfunction

function ret = det_jac( p )
  global kd l c x0;
  omega = p(1); y = p(2);
  ret = kd+(omega**2)*(l*cos(2*y)-cos(y));
endfunction

function y = beq(x,om)
  global kd l c x0;
  y(1) = kd * (x - x0) + om**2 * sin(x)*(l*cos(x)-1);
  y(2) = kd+(omega**2)*(l*cos(2*y(1))-cos(y(1)));
endfunction

#####
function ret = iswap( i )
  ret = rem(i, 2) + 1;
endfunction

function ret = auto_conti( func, x0, xr, dx, nmax, inc_i, dir )
  global fr_i q;
  n = 0; err = 0;
  fr_i = iswap(inc_i);
  q = x0; ret = [];
  while ( n <= nmax 
          && xr(1,1) <= q(1) && q(1) <= xr(1,2) 
          && xr(2,1) <= q(2) && q(2) <= xr(2,2) )
    [q(fr_i),err] = fsolve( func, q(fr_i) );
    if ( abs(det_jac(q)) < 2e3 && inc_i == 1 )
      abs(det_jac(q))
      err = -1;
    endif
    if ( abs(det_jac(q)) > 2e3 && inc_i == 2 )
      abs(det_jac(q))
      err = -1;
    endif
    if ( err == 1 ) # success
      ret = [ret;q];
      n++; q(inc_i) += dir*dx(inc_i);
    else
#      abs(det_jac(q))
#      perror("fsolve", err);
      n--; q(inc_i) -= dir*dx(inc_i);
      dir = sign(ret(n,fr_i) - ret(n-1,fr_i));
      printf( "direction = %d\n", dir );
      if ( dir == 0 )
        printf( "invalid direction\n" ); exit;
      endif
      inc_i = iswap(inc_i);
      fr_i = iswap(fr_i);
    endif
  endwhile
endfunction

function [cs, cu] = stability(cp_all)
  global kd l c x0 omega;
  len=length(cp_all); #}̔z
  cp_s=[]; cp_u=[];
  for i=1:len
    omega = cp_all(i,1); #omega
    y(1) = cp_all(i,2);  #
    stab = max(real(eig(jac(y)))); #RršŗLlmax
    if ( stab < 0 )
      cp_s = [cp_s;[omega,y(1)]];  #}̈蕔
    else
      cp_u = [cp_u;[omega,y(1)]];  #}̕s蕔
    endif
  endfor
  cs = cp_s; cu = cp_u;
endfunction
